---
title: /v2/advertisers/{advertiserId}/campaigns/{campaignId}/spa/ad-groups/search
slug: campaign-reporting-apis/v2advertisersadvertiseridcampaignscampaignidspaad-groupssearch
docTags: 
createdAt: 2026-03-25T10:57:30.256Z
---

{
  "id": "qYKZUDacfJS78Xg5G7ex8",
  "type": "api-oas-v2",
  "data": {
    "method": "POST",
    "url": "https://<pcm-domain>/v2/advertisers/{advertiserId}/campaigns/{campaignId}/spa/ad-groups/search",
    "servers": [
      {
        "url": "https://<pcm-domain>/v2/advertisers/{advertiserId}/campaigns/{campaignId}/spa/ad-groups/search",
        "description": "Generated server url"
      }
    ],
    "name": "",
    "description": "<p>Retrieves filtered and paginated SPA ad groups for a campaign.</p>\n<p><strong>Rules:</strong></p>\n<ul>\n<li>The <em>values</em> array for the <em>MODIFIED_AFTER</em> filter must take exactly one value in the format <em>yyyy-MM-dd'T'HH:mm<div></div>.SSS'Z'</em> e.g. <em>{\"field\":\"MODIFIED_AFTER\", \"values\":[\"2025-02-05T12:34<div></div>.000Z\"]}</em>.</li>\n</ul>\n<p><strong>Notes:</strong></p>\n<ul>\n<li><em>sortType</em> defaults to ascending if not passed.</li>\n</ul>",
    "contentType": "application/json",
    "request": {
      "pathParameters": [
        {
          "kind": "required",
          "name": "advertiserId",
          "type": "integer<int32>",
          "description": "",
          "format": "int32"
        },
        {
          "kind": "required",
          "name": "campaignId",
          "type": "integer<int32>",
          "description": "",
          "format": "int32"
        }
      ],
      "headerParameters": [],
      "queryParameters": [],
      "bodyDataParameters": [
        {
          "kind": "required",
          "name": "body",
          "type": "object",
          "description": "",
          "customType": "SpaAdGroupSearchRequest",
          "schema": [
            {
              "name": "filters",
              "kind": "optional",
              "type": "array",
              "description": "",
              "modelRef": "#/components/schemas/FilterValuesSpaAdGroupFilterField",
              "customType": "FilterValuesSpaAdGroupFilterField[]",
              "schema": [
                {
                  "name": "field",
                  "kind": "optional",
                  "type": "string<STATUS | AD_GROUP | MODIFIED_AFTER>",
                  "description": "",
                  "example": "",
                  "enum": [
                    "STATUS",
                    "AD_GROUP",
                    "MODIFIED_AFTER"
                  ]
                },
                {
                  "name": "values",
                  "kind": "optional",
                  "type": "array",
                  "description": "",
                  "example": "",
                  "itemType": "object",
                  "customType": "object[]",
                  "itemExample": "",
                  "itemDefault": ""
                }
              ]
            },
            {
              "name": "page",
              "kind": "required",
              "type": "integer<int32>",
              "description": "",
              "example": 0,
              "format": "int32",
              "minimum": 0,
              "maximum": 1000
            },
            {
              "name": "limit",
              "kind": "required",
              "type": "integer<int32>",
              "description": "",
              "example": 0,
              "format": "int32",
              "minimum": 1,
              "maximum": 10000
            },
            {
              "name": "sortType",
              "kind": "optional",
              "type": "string<ASC | DESC>",
              "description": "",
              "example": "",
              "enum": [
                "ASC",
                "DESC"
              ]
            },
            {
              "name": "orderBy",
              "kind": "required",
              "type": "string<AD_GROUP | STATUS | MARKET | BUDGET | BUDGET_SPENT | SPEND_VELOCITY | START_DATE | END_DATE | PUBLISHER>",
              "description": "",
              "example": "",
              "enum": [
                "AD_GROUP",
                "STATUS",
                "MARKET",
                "BUDGET",
                "BUDGET_SPENT",
                "SPEND_VELOCITY",
                "START_DATE",
                "END_DATE",
                "PUBLISHER"
              ]
            }
          ],
          "modelRef": "#/components/schemas/SpaAdGroupSearchRequest",
          "isExpanded": true
        }
      ],
      "formDataParameters": [],
      "oAuthParameters": []
    },
    "responses": [
      {
        "statusCode": "200",
        "description": "OK",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "",
            "customType": "ListResponseSpaAdGroupResponseVoid",
            "schema": [
              {
                "name": "detailed",
                "kind": "optional",
                "type": "array",
                "description": "",
                "modelRef": "#/components/schemas/SpaAdGroupResponse",
                "customType": "SpaAdGroupResponse[]",
                "schema": [
                  {
                    "name": "id",
                    "kind": "optional",
                    "type": "integer<int32>",
                    "description": "",
                    "example": 0,
                    "format": "int32"
                  },
                  {
                    "name": "publisher",
                    "kind": "optional",
                    "type": "object",
                    "description": "",
                    "modelRef": "#/components/schemas/PublisherWithGlobalFloorPriceResponse",
                    "customType": "PublisherWithGlobalFloorPriceResponse",
                    "schema": [
                      {
                        "name": "id",
                        "kind": "optional",
                        "type": "integer<int32>",
                        "description": "",
                        "example": 0,
                        "format": "int32"
                      },
                      {
                        "name": "name",
                        "kind": "optional",
                        "type": "string",
                        "description": "",
                        "example": ""
                      },
                      {
                        "name": "bidBelowGlobalFloorPrice",
                        "kind": "optional",
                        "type": "boolean",
                        "description": "",
                        "example": ""
                      }
                    ]
                  },
                  {
                    "name": "name",
                    "kind": "optional",
                    "type": "string",
                    "description": "",
                    "example": ""
                  },
                  {
                    "name": "type",
                    "kind": "optional",
                    "type": "string<DISPLAY | SPA | SPONSORED_BRAND>",
                    "description": "",
                    "example": "",
                    "enum": [
                      "DISPLAY",
                      "SPA",
                      "SPONSORED_BRAND"
                    ]
                  },
                  {
                    "name": "status",
                    "kind": "optional",
                    "type": "string<ARCHIVED | EXPIRED | LIVE | PAUSED | SCHEDULED | WAITING | REJECTED>",
                    "description": "",
                    "example": "",
                    "enum": [
                      "ARCHIVED",
                      "EXPIRED",
                      "LIVE",
                      "PAUSED",
                      "SCHEDULED",
                      "WAITING",
                      "REJECTED"
                    ]
                  },
                  {
                    "name": "budget",
                    "kind": "optional",
                    "type": "number",
                    "description": "",
                    "example": ""
                  },
                  {
                    "name": "budgetSpent",
                    "kind": "optional",
                    "type": "number",
                    "description": "",
                    "example": ""
                  },
                  {
                    "name": "dailyBudget",
                    "kind": "optional",
                    "type": "number",
                    "description": "",
                    "example": ""
                  },
                  {
                    "name": "weeklyBudget",
                    "kind": "optional",
                    "type": "number",
                    "description": "",
                    "example": ""
                  },
                  {
                    "name": "monthlyBudget",
                    "kind": "optional",
                    "type": "number",
                    "description": "",
                    "example": ""
                  },
                  {
                    "name": "useDynamicBudget",
                    "kind": "optional",
                    "type": "boolean",
                    "description": "Whenever dynamic budget is activated daily limits are calculated in order that the remaining budget is evenly distributed over the ad group's lifetime.",
                    "example": ""
                  },
                  {
                    "name": "dailySpendPacing",
                    "kind": "optional",
                    "type": "string<ASAP | EVEN>",
                    "description": "",
                    "example": "",
                    "enum": [
                      "ASAP",
                      "EVEN"
                    ]
                  },
                  {
                    "name": "spendVelocity",
                    "kind": "optional",
                    "type": "number<double>",
                    "description": "The pacing of the ad group measures budget efficiency over time, where a value of 1.0 reflects ideal spend considering temporal progress of the ad group, less than 1.0 underspending, and more than 1.0 overspending. The value is not set whenever the ad group has no end date.",
                    "example": "",
                    "format": "double"
                  },
                  {
                    "name": "startDate",
                    "kind": "optional",
                    "type": "string<date-time>",
                    "description": "",
                    "example": "",
                    "format": "date-time"
                  },
                  {
                    "name": "endDate",
                    "kind": "optional",
                    "type": "string<date-time>",
                    "description": "",
                    "example": "",
                    "format": "date-time"
                  },
                  {
                    "name": "targetedSiteIds",
                    "kind": "optional",
                    "type": "array",
                    "description": "",
                    "example": "",
                    "itemType": "integer",
                    "customType": "integer[]",
                    "itemExample": "",
                    "itemDefault": ""
                  },
                  {
                    "name": "targetedLocations",
                    "kind": "optional",
                    "type": "array",
                    "description": "",
                    "modelRef": "#/components/schemas/AdGroupTargetLocation",
                    "customType": "AdGroupTargetLocation[]",
                    "schema": [
                      {
                        "name": "location",
                        "kind": "optional",
                        "type": "string<CATEGORY_PAGE | SEARCH_PAGE | HOME_PAGE | PRODUCT_PAGE | CHECKOUT | MINI_SEARCH | EMAIL | EMAIL_ABANDONED_CART>",
                        "description": "",
                        "example": "",
                        "enum": [
                          "CATEGORY_PAGE",
                          "SEARCH_PAGE",
                          "HOME_PAGE",
                          "PRODUCT_PAGE",
                          "CHECKOUT",
                          "MINI_SEARCH",
                          "EMAIL",
                          "EMAIL_ABANDONED_CART"
                        ]
                      },
                      {
                        "name": "pagePosition",
                        "kind": "optional",
                        "type": "string<MAIN_GRID | CAROUSEL | BELOW_THE_FOLD | ABOVE_THE_FOLD | L1 | L2 | L3 | L4>",
                        "description": "",
                        "example": "",
                        "enum": [
                          "MAIN_GRID",
                          "CAROUSEL",
                          "BELOW_THE_FOLD",
                          "ABOVE_THE_FOLD",
                          "L1",
                          "L2",
                          "L3",
                          "L4"
                        ]
                      }
                    ]
                  },
                  {
                    "name": "advertised",
                    "kind": "optional",
                    "type": "boolean",
                    "description": "",
                    "example": ""
                  },
                  {
                    "name": "globalFloorPrice",
                    "kind": "optional",
                    "type": "number",
                    "description": "",
                    "example": ""
                  },
                  {
                    "name": "modifiedAt",
                    "kind": "optional",
                    "type": "string<date-time>",
                    "description": "",
                    "example": "",
                    "format": "date-time"
                  }
                ]
              },
              {
                "name": "aggregated",
                "kind": "optional",
                "type": "object",
                "description": "",
                "modelRef": "#/components/schemas/AggregatedVoid",
                "customType": "AggregatedVoid",
                "schema": [
                  {
                    "name": "count",
                    "kind": "optional",
                    "type": "integer<int64>",
                    "description": "",
                    "example": 0,
                    "format": "int64"
                  },
                  {
                    "name": "metrics",
                    "kind": "optional",
                    "type": "",
                    "description": "",
                    "example": ""
                  }
                ]
              }
            ],
            "modelRef": "#/components/schemas/ListResponseSpaAdGroupResponseVoid",
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "401",
        "description": "Unauthorized",
        "jsonExample": "",
        "isExpanded": true
      },
      {
        "statusCode": "403",
        "description": "Forbidden",
        "jsonExample": "",
        "isExpanded": true
      },
      {
        "statusCode": "404",
        "description": "Not Found",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "",
            "customType": "ExceptionResponse",
            "schema": [
              {
                "name": "messages",
                "kind": "optional",
                "type": "array",
                "description": "",
                "example": "",
                "itemType": "string",
                "customType": "string[]",
                "itemExample": "",
                "itemDefault": ""
              }
            ],
            "modelRef": "#/components/schemas/ExceptionResponse",
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "422",
        "description": "Unprocessable Entity",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "",
            "customType": "ExceptionResponse",
            "schema": [
              {
                "name": "messages",
                "kind": "optional",
                "type": "array",
                "description": "",
                "example": "",
                "itemType": "string",
                "customType": "string[]",
                "itemExample": "",
                "itemDefault": ""
              }
            ],
            "modelRef": "#/components/schemas/ExceptionResponse",
            "isExpanded": true
          }
        ]
      }
    ],
    "hasXCodeSamples": false,
    "examples": {
      "languages": [
        {
          "id": "V2QZsYduMVvZwvgC1CHPR",
          "language": "curl",
          "label": "cURL",
          "code": "curl --request POST \\\n     --url https://<pcm-domain>/v2/advertisers/{advertiserId}/campaigns/{campaignId}/spa/ad-groups/search \\\n     --header 'accept: application/json' \\\n     --header 'content-type: application/json' \\\n     --data '{\n     \"page\": 0,\n     \"limit\": 0,\n     \"orderBy\": \"\"\n     }'"
        },
        {
          "id": "CQDYl0EmkrTegi5Y5Jxn8",
          "language": "javascript",
          "label": "javascript",
          "code": "var myHeaders = new Headers();\nmyHeaders.append(\"accept\", \"application/json\");\nmyHeaders.append(\"content-type\", \"application/json\");\n\nvar raw = JSON.stringify({\n   \"page\": 0,\n   \"limit\": 0,\n   \"orderBy\": \"\"\n});\n\nvar requestOptions = {\n   method: 'POST',\n   headers: myHeaders,\n   body: raw,\n   redirect: 'follow'\n};\n\nfetch(\"https://<pcm-domain>/v2/advertisers/{advertiserId}/campaigns/{campaignId}/spa/ad-groups/search\", requestOptions)\n   .then(response => response.text())\n   .then(result => console.log(result))\n   .catch(error => console.log('error', error));"
        },
        {
          "id": "QFTE9Fkr_lLXKhJo9ZaL8",
          "language": "ruby",
          "label": "Ruby",
          "code": "require \"uri\"\nrequire \"json\"\nrequire \"net/http\"\n\nurl = URI(\"https://<pcm-domain>/v2/advertisers/{advertiserId}/campaigns/{campaignId}/spa/ad-groups/search\")\n\nhttps = Net::HTTP.new(url.host, url.port)\nhttps.use_ssl = true\n\nrequest = Net::HTTP::Post.new(url)\nrequest[\"accept\"] = \"application/json\"\nrequest[\"content-type\"] = \"application/json\"\nrequest.body = JSON.dump({\n   \"page\": 0,\n   \"limit\": 0,\n   \"orderBy\": \"\"\n})\n\nresponse = https.request(request)\nputs response.read_body\n"
        },
        {
          "id": "Pg8pxdimK5T5ju0qyiCzl",
          "language": "python",
          "label": "Python",
          "code": "import requests\nimport json\n\nurl = \"https://<pcm-domain>/v2/advertisers/{advertiserId}/campaigns/{campaignId}/spa/ad-groups/search\"\n\npayload = json.dumps({\n   \"page\": 0,\n   \"limit\": 0,\n   \"orderBy\": \"\"\n})\nheaders = {\n   'accept': 'application/json',\n   'content-type': 'application/json'\n}\n\nresponse = requests.request(\"POST\", url, headers=headers, data=payload)\n\nprint(response.text)\n"
        }
      ],
      "selectedLanguageId": "V2QZsYduMVvZwvgC1CHPR"
    },
    "results": {
      "languages": [
        {
          "id": "response-0-200",
          "language": "200",
          "code": "// OK\n{\n  \"detailed\": [\n    {\n      \"id\": \"\",\n      \"publisher\": {\n        \"id\": \"\",\n        \"name\": \"\",\n        \"bidBelowGlobalFloorPrice\": false\n      },\n      \"name\": \"\",\n      \"type\": \"\",\n      \"status\": \"\",\n      \"budget\": 0,\n      \"budgetSpent\": 0,\n      \"dailyBudget\": 0,\n      \"weeklyBudget\": 0,\n      \"monthlyBudget\": 0,\n      \"useDynamicBudget\": false,\n      \"dailySpendPacing\": \"\",\n      \"spendVelocity\": \"\",\n      \"startDate\": \"\",\n      \"endDate\": \"\",\n      \"targetedSiteIds\": [\n        0\n      ],\n      \"targetedLocations\": [\n        {\n          \"location\": \"\",\n          \"pagePosition\": \"\"\n        }\n      ],\n      \"advertised\": false,\n      \"globalFloorPrice\": 0,\n      \"modifiedAt\": \"\"\n    }\n  ],\n  \"aggregated\": {\n    \"count\": \"\",\n    \"metrics\": \"\"\n  }\n}"
        },
        {
          "id": "response-1-401",
          "language": "401",
          "code": "// Unauthorized\n"
        },
        {
          "id": "response-2-403",
          "language": "403",
          "code": "// Forbidden\n"
        },
        {
          "id": "response-3-404",
          "language": "404",
          "code": "// Not Found\n{\n  \"messages\": [\n    \"\"\n  ]\n}"
        },
        {
          "id": "response-4-422",
          "language": "422",
          "code": "// Unprocessable Entity\n{\n  \"messages\": [\n    \"\"\n  ]\n}"
        }
      ],
      "selectedLanguageId": "response-0-200"
    }
  },
  "children": [
    {
      "text": ""
    }
  ]
}